/* ========================================
 *
 * Copyright xxxx
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"

#include "main.h"


#define REG(addr) (*((volatile uint32 *) (addr)))
#define CM0_ISER_REG REG( 0xE000E100 )
#define CPUSS_SYSREQ_REG REG( 0x40100004 )
#define CPUSS_SYSARG_REG REG( 0x40100008 )


/*Variable to keep track of how many times SPC ISR is triggered */
//__ram int iStatusInt = 0x00;
int iStatusInt = 0x00;
uint32 tmp32;


//CY_SECTION(".sramCode") __attribute__((used))
//CY_SECTION(".sramCode") __attribute__((used))
__attribute__( (section(".ram") ) ) void NonBlockingWriteRow(void)
{
int i,syscall_status;
/*Load the Flash page latch with data to write
* Write key1, key2, byte address, and macro sel parameters to SRAM
*/
//REG( 0x20000000 ) = 0x0000D7B6;
REG( 0x20000A00 ) = 0x0000D7B6;

//Write load size param (128 bytes) to SRAM
//REG( 0x20000004 ) = 0x0000007F;
REG( 0x20000A00 + 4 ) = 0x0000007F;
//for(i = 0; i < ROW_SIZE/4; i += 1)
for(i = 0; i < 128/4; i += 1)
{
//REG( 0x20000008 + i*4 ) = 0x12345678;
REG( 0x20000A08 + i*4 ) = 0x12345678;
}
/*Write the address of the key1 param to CPUSS_SYSARG reg*/
//CPUSS_SYSARG_REG = 0x20000000;
CPUSS_SYSARG_REG = 0x20000A00;
/*Write the API opcode = 0x04 to CPUSS_SYSREQ.COMMAND
* register and assert the sysreq bit
*/
CPUSS_SYSREQ_REG = 0x80000004;
/*Perform Non-Blocking Write Row on Row 200 as an example.
* Write key1, key2, row id to SRAM row id = 0xC8 -> which is row 200
*/
//REG( 0x20000000 ) = 0x00C8DAB6;
REG(0x20000A00 ) = 0x00C8DAB6;
/*Write the address of the key1 param to CPUSS_SYSARG reg */
//CPUSS_SYSARG_REG = 0x20000000;
CPUSS_SYSARG_REG = 0x20000A00;
/*Write the API opcode = 0x07 to CPUSS_SYSREQ.COMMAND
* register and assert the sysreq bit
*/
CPUSS_SYSREQ_REG = 0x80000007;
/*Execute user code until iStatusInt equals 3 to signify
* 3 SPC interrupts have happened. This should be 1 in case
* of non-blocking program System Call
*/
while( iStatusInt != 0x03 )
{
    
//DoOtherUserStuff();
    tmp32 = (uint32)((((*(reg8*)(CPUSS_SYSARG_REG))) + 
                      (((*(reg8*)(CPUSS_SYSARG_REG+1)))<<8) +
                      (((*(reg8*)(CPUSS_SYSARG_REG+2)))<<16) +
                      (((*(reg8*)(CPUSS_SYSARG_REG+3)))<<24)));
}
 
/* Get the success or failure status of System Call*/
syscall_status = CPUSS_SYSARG_REG;
Pin_relay1_Write(1);
tmp32 = tmp32+1;
}
//CY_SECTION(".sramCode") __attribute__((used))
__attribute__( (section(".ram") ) ) CY_ISR_PROTO(SpcIntHandler)
{
/* Write key1, key2 parameters to SRAM */
//REG( 0x20000000 ) = 0x0000DCB6;
REG( 0x20000A00) = 0x0000DCB6;
/*Write the address of key1 to the CPUSS_SYSARG reg */
//CPUSS_SYSARG_REG = 0x20000000;
CPUSS_SYSARG_REG = 0x20000A00;
/*Write the API opcode = 0x09 to the CPUSS_SYSREQ.COMMAND
* register and assert the sysreq bit
*/
CPUSS_SYSREQ_REG = 0x80000009;
/* Number of times the ISR has triggered */
iStatusInt ++;
}

//CY_SECTION(".sramCode") __attribute__((used))
//CY_SECTION(".rom") __USED

int main(void)
{
       /* Link and enable the SPC interrupt */
    CyIntSetVector(12,SpcIntHandler);           //IRQ12 is SPCIF
    CyIntSetPriority(12,3);
    CyIntEnable(12);

/*CM0+ interrupt enable bit for spc interrupt enable */
//CM0_ISER_REG |= 0x00000040;
CM0_ISER_REG |= 0x00001000;  //Enable SPCIF interrupt (bit12)


   __enable_irq(); 
    CyGlobalIntEnable; /* Enable global interrupts. */
    Pin_relay1_SetDriveMode(Pin_relay1_DM_STRONG);
    Pin_relay2_SetDriveMode(Pin_relay2_DM_STRONG);

    
/*Call non-blocking write row API */
    NonBlockingWriteRow();
    
    for(;;)
    {
        /* Place your application code here. */
        
    }
}

/* [] END OF FILE */
